

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// Arduino UNO
//
////////////////////////
//анимированный РОТ ДЛЯ БЛЮЧИКЕНА
//
#include <Servo.h>
Servo myservoRT;
Servo myservoGL; 

int pos = 60;//переменная хранения текущего значения угла поворота используемого сервопривода рта
String inputString;// строки данных
boolean FL=false;//флаг состояний окончания и начала речи

void setup ()
{
 Serial.begin(9600);
 myservoRT.attach(7);//"вывод для управления ртом"
 myservoGL.attach(6);//"вывод для управления глазами"
 myservoGL.write(90);// исходные положения частей аниматроника 
 myservoRT.write(pos);
 
 
}
////////////////////////////
void loop()
{
  CheckSerial();//ЖДЁМ ПОСТУПЛЕНИЯ КОМАНДЫ 
}

/////////////////////////////////////////////////////////////////////////////////////////////////
//ФУНКЦИИ ПРИЁМА И ОБРАБОТКИ ДАННЫХ
void CheckSerial()
{
  //////////////////////////////////////////////////////////////////////////////
  while (Serial.available())//считываем строку данных пока они поступают
  {
    char inChar = (char)Serial.read();
    if (inChar == '\n')     //если окончание строки
    {
      MakeCmd();//обрабатываем её данной функцией
      break;
    }
    else inputString += inChar;// иначе удлиняем строку на один символ
  }
}
/////////////////////////////////////////////////////////////////////////////////
void MakeCmd()
{
  int y = inputString.length(); // присваиваем переменной у число символов в строке
  if (y < 1 || y > 1)return; //если их меньше 1 или больше, выходим из функции
  String cmd = inputString; // передаём строку другой переменной
  inputString = "";//"обнуляем переменную"

  if (cmd == "A") {
  Glaza();delay (2000);Rot_A();Serial.print("B");delay(250);Rot_B();delay(450);FL=true;
   }
  if (cmd == "C") {
   if(FL==true){Rot_A();Serial.print("B");delay(250);Rot_B();delay(450);} 
   }
  if (cmd == "D") {
    FL=false; Glaza(); 
   }
}
////////////////////////////////////
void Rot_A()//функция движений рта при послоговом проговаривании - открыть
{
for (pos = 60; pos <= 100; pos += 4) { 
    myservoRT.write(pos);            
    delay(6);                       
  }
   
}
////////////////////////////////////
void Rot_B()//функция движений рта при послоговом проговаривании - закрыть
{

   for (pos = 100; pos >= 60; pos -= 4) { 
    myservoRT.write(pos);            
    delay(6);                      
  }
}
////////////////////////////////////

void Glaza()//функция поворота глаз
{
 
  for (pos = 90; pos <= 160; pos += 1) { 
    if(pos==90){delay(500); }
    myservoGL.write(pos);            
    delay(7);                       
  }
   delay(500); 
  for (pos = 160; pos >= 20; pos -= 1) { 
     if(pos==90){delay(500); }
    myservoGL.write(pos);            
    delay(7);                      
  }
   delay(500); 
   for (pos = 20; pos <= 90; pos += 1) { 
    myservoGL.write(pos);            
    delay(7);                       
  }
   
 
}
/////////////////////////////////////////////////////////////////////////////////

